var EXPORTED_SYMBOLS = ['AfUrlHelper'];
Ci = Components.interfaces;
Cc = Components.classes;
Cr = Components.results;


AfUrlHelper = {
  
    _cout : Cc["@mozilla.org/consoleservice;1"].getService(Ci.nsIConsoleService),
    
    _fbw_start_url : "http://127.0.0.1:895/config/adlink_",
    
    _initialized : false,
    
    _br_version : "4.0",
    
    _regMonitorInterval: 0,

    _prefsProxy: null,
    
    _prefsAfExt: null,

    _proxyRegKey: null,

    
    // nsIContentPolicy implementation
    shouldLoad: function(contentType, contentLocation, requestOrigin, aContext, mimeTypeGuess, extra) {
        
        if ( !this._initialized ) {    
            var wm = Cc["@mozilla.org/appshell/window-mediator;1"].getService(Ci.nsIWindowMediator);  
            var mainWindow = wm.getMostRecentWindow("navigator:browser");
            if ( mainWindow && mainWindow.gBrowser ) {
                var container = mainWindow.gBrowser.tabContainer;
                if ( container )
                {
                    container.addEventListener("TabOpen", function (event) { AfUrlHelper.handleEvent (event); }, false);  
                    container.addEventListener("TabSelect", function (event) { AfUrlHelper.handleEvent (event); }, false);  
                    container.addEventListener("TabClose", function (event) { AfUrlHelper.handleEvent (event); }, false);  
                    mainWindow.addEventListener("resize", function (event) { AfUrlHelper.handleEvent (event); }, false); 
                    
                    this.proxyInit();
                    this._regMonitorInterval = mainWindow.setInterval(this.queryProxyRegKey, 1000, this);
                    
                    this._initialized = true;
                }
            }
        }
        
        if (contentLocation.scheme != "http" && contentLocation.scheme != "https") {
            return Ci.nsIContentPolicy.ACCEPT;
        } //Immediately, otherwise we will log all sorts of crap
                    
        try {
            if (contentType == Ci.nsIContentPolicy.TYPE_SCRIPT) {
                            
                var wm = Cc["@mozilla.org/appshell/window-mediator;1"].getService(Ci.nsIWindowMediator);  
                var mainWindow = wm.getMostRecentWindow("navigator:browser");
                if ( mainWindow ) {
                    
                    if ( contentLocation.spec.indexOf(this._fbw_start_url) >= 0 && contentLocation.spec.indexOf('&ext=yes') < 0 ) {                        
                                            
                        var selTab = mainWindow.gBrowser.selectedTab;
                        
                        var selTabPanel = mainWindow.document.getElementById(selTab.linkedPanel);   
                        
                        var fbw_url = contentLocation.spec + '&ext=yes';
                        
                        fbw_url = fbw_url + '&tabX=' + selTabPanel.boxObject.screenX;
                        fbw_url = fbw_url + '&tabY=' + selTabPanel.boxObject.screenY;
                        fbw_url = fbw_url + '&tabW=' + selTabPanel.boxObject.width;
                        fbw_url = fbw_url + '&tabH=' + selTabPanel.boxObject.height;  
                        
                        fbw_url = fbw_url + '&wndX=' + mainWindow.screenX;
                        fbw_url = fbw_url + '&wndY=' + mainWindow.screenY;
                        fbw_url = fbw_url + '&wndW=' + mainWindow.outerWidth;
                        fbw_url = fbw_url + '&wndH=' + mainWindow.outerHeight;
                        
                        contentLocation.spec = fbw_url;
                        
                        //this._cout.logStringMessage('AfUrlHelper::shouldLoad ' + contentLocation.spec);
                    }
                }
            }
        } catch(e) {
            this._cout.logStringMessage('AfUrlHelper::shouldLoad ' + e);                    
        }
        
        return Ci.nsIContentPolicy.ACCEPT;
        
    },
    
    shouldProcess: function(contentType, contentLocation, requestOrigin, insecNode, mimeType, extra) {
        return Ci.nsIContentPolicy.ACCEPT;
    },
    //end nsIContentPolicy
    
    handleEvent : function(event) {
        //this._cout.logStringMessage('AfUrlHelper::handleEvent ' + event.type );
        this.buildFbwUrl(event);
    },
    
    buildFbwUrl : function(event) {
        try {
            var fbw_url = this._fbw_start_url;
                    
            fbw_url += ((Math.floor(Math.random()*9999)) + '.html?act=');
            
            switch ( event.type )
            {
            case 'TabOpen':
                fbw_url += 'xload';
                break;
            case 'TabSelect':
                fbw_url += "focus";
                break;
            case 'TabClose':
                fbw_url += "xunload";
                break;
            case 'resize':
                fbw_url += "xresize";
                break;
            }

            fbw_url += ("&br=2&brv=" + _br_version);

            fbw_url += "&ext=yes";
            
            var wm = Cc["@mozilla.org/appshell/window-mediator;1"].getService(Ci.nsIWindowMediator);  
            var mainWindow = wm.getMostRecentWindow("navigator:browser");
            if ( mainWindow ) {
                                    
                var selTab = mainWindow.gBrowser.selectedTab;
                var selTabBr = mainWindow.gBrowser.getBrowserForTab( selTab );
                
                var selTabPanel = mainWindow.document.getElementById(selTab.linkedPanel);
                
                if ( mainWindow.content.name != '' ) {
                
                    fbw_url = fbw_url + '&wid=' + mainWindow.content.name;
                
                    fbw_url = fbw_url + '&tabX=' + selTabPanel.boxObject.screenX;
                    fbw_url = fbw_url + '&tabY=' + selTabPanel.boxObject.screenY;
                    fbw_url = fbw_url + '&tabW=' + selTabPanel.boxObject.width;
                    fbw_url = fbw_url + '&tabH=' + selTabPanel.boxObject.height;  
                    
                    fbw_url = fbw_url + '&wndX=' + mainWindow.screenX;
                    fbw_url = fbw_url + '&wndY=' + mainWindow.screenY;
                    fbw_url = fbw_url + '&wndW=' + mainWindow.outerWidth;
                    fbw_url = fbw_url + '&wndH=' + mainWindow.outerHeight;
                    
                    //this._cout.logStringMessage('AfUrlHelper::buildFbwUrl ' + fbw_url);
        
                    var req = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]  
                            .createInstance(Components.interfaces.nsIXMLHttpRequest);  
                    req.open('GET', fbw_url, true); /* asynchronous! */  
                    req.send(null);  
                }
            }
        } catch(e) {
            this._cout.logStringMessage('AfUrlHelper::shouldLoad ' + e);                    
        }
    },
  
    proxyInit: function () {
        var prefManager = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefService);
        
        this._prefsProxy = prefManager.getBranch("network.proxy.");
        this._prefsAfExt = prefManager.getBranch("extensions.afurladvisor.");
        
        try {                
            var bkpProxyType = this._prefsAfExt.getIntPref("bkp_proxy_type");
        } catch(e) {
            this._prefsAfExt.setIntPref("bkp_proxy_type", -1);            
        }

        // Set up a monitor the AnchorFree\Proxy
        this.setProxyRegKeyMonitor();
                
        try {                
            var isFirstRun = this._prefsAfExt.getBoolPref("firstrun");
        } catch(e) {
            isFirstRun = false;        
        }
        
        if ( isFirstRun ) {
            try {        
                var prefsBrowser = prefManager.getBranch("browser.startup.");
                
                var prefsBrowserSrch = prefManager.getBranch("browser.search.");
                var prefsKeyword = prefManager.getBranch("keyword.");
                
                var afHomePage = this._prefsAfExt.getCharPref("homepage");
                if ( afHomePage != '' )
                    prefsBrowser.setCharPref("homepage", afHomePage);
                    
                var afDefSearchEng = this._prefsAfExt.getCharPref("defaultenginename");
                if ( afDefSearchEng != '' )
                    prefsBrowserSrch.setCharPref("defaultenginename", afDefSearchEng);
                    
                var afSearchEng = this._prefsAfExt.getCharPref("selectedEngine");
                if ( afSearchEng != '' )
                    prefsBrowserSrch.setCharPref("selectedEngine", afSearchEng);    

                var afKeywordURL = this._prefsAfExt.getCharPref("keywordURL");
                if ( afKeywordURL != '' )
                    prefsKeyword.setCharPref("keywordURL", afKeywordURL);    
                    
                this._prefsAfExt.setBoolPref("firstrun", false);    
            
            } catch(e) {
                
            }
        }
    },

    //
    // This function is called when our addon is unloaded.  It stops monitoring the keys.
    //
    proxyUninit: function () {
        window.clearInterval(this._regMonitorInterval);

        if (null != this._proxyRegKey) {
            this._proxyRegKey.stopWatching();
            this._proxyRegKey.close();
        }
    },

    // 
    // Try to open the Proxy registry keys and read its settings.
    // Then, get the isProxyOn value and set up an observer for changes.
    //
    setProxyRegKeyMonitor: function () {
        try {
            this._proxyRegKey = Cc["@mozilla.org/windows-registry-key;1"].createInstance(Ci.nsIWindowsRegKey);
            this._proxyRegKey.open(this._proxyRegKey.ROOT_KEY_CURRENT_USER, "SOFTWARE\\AnchorFree\\prff", this._proxyRegKey.ACCESS_READ); 
                        
            this._proxyRegKey.startWatching(false);

            try {
                this.isProxyOn = (0 != this._proxyRegKey.readIntValue("proxy"));
                
                var curProxyType = this._prefsProxy.getIntPref("type");
                if ( this.isProxyOn ) {
                    if ( curProxyType != 5 ) {
                        this._prefsAfExt.setIntPref("bkp_proxy_type", curProxyType);
                        this._prefsProxy.setIntPref("type", 5); 
                    }
                }
                else {
                    var bkpProxyType = this._prefsAfExt.getIntPref("bkp_proxy_type");
                    if ( bkpProxyType >= 0 ) {
                        this._prefsProxy.setIntPref("type", bkpProxyType); 
                        this._prefsAfExt.setIntPref("bkp_proxy_type", -1);
                    }
                }
            }
            catch (e) { }

            //this._cout.logStringMessage('AfUrlHelper::setProxyRegKeyMonitor isProxyOn = ' + this.isProxyOn);
            //this._cout.logStringMessage('type = ' + this._prefsProxy.getIntPref("type") );
            
            return true;
        }
        catch (e) {
            this._cout.logStringMessage('AfUrlHelper::setProxyRegKeyMonitor ' + e);
            return false;
        }
    },

    // This callback function executes if the \Software\AnchorFree\Proxy DWORD changes
    //
    queryProxyRegKey: function (oObj) {
            
        //oObj._cout.logStringMessage('isProxyOn = ' + oObj.isProxyOn );
        //oObj._cout.logStringMessage('type = ' + oObj._prefsProxy.getIntPref("type") );
    
        if ((null == oObj._proxyRegKey) || !oObj._proxyRegKey.hasChanged()) return;  // return quickly

        var i = 0;
        try {
            i = oObj._proxyRegKey.readIntValue("proxy");
        }
        catch (e) {
            i = 0;
        }

        // "this" isn't the object you might expect, so we pass 'ourselves' using oObj.  There's a good (complicated) reason for that; 
        // see https://developer.mozilla.org/en/Core_JavaScript_1.5_Reference/Operators/Special_Operators/this_Operator#Method_binding
        oObj.isProxyOn = (0 != i);
        
        var curProxyType = oObj._prefsProxy.getIntPref("type");
        if ( oObj.isProxyOn ) {
            if ( curProxyType != 5 ) {
                oObj._prefsAfExt.setIntPref("bkp_proxy_type", curProxyType);
                oObj._prefsProxy.setIntPref("type", 5); 
            }
        }
        else {
            var bkpProxyType = oObj._prefsAfExt.getIntPref("bkp_proxy_type");
            if ( bkpProxyType >= 0 ) {
                oObj._prefsProxy.setIntPref("type", bkpProxyType); 
                oObj._prefsAfExt.setIntPref("bkp_proxy_type", -1);
            }
        }
    },

    init : function(e) {
        this._cout.logStringMessage('AfUrlHelper CREATED');
        
        // assuming we're running under Firefox  
        var appInfo = Cc["@mozilla.org/xre/app-info;1"]  
                                .getService(Ci.nsIXULAppInfo);  
                                
        _br_version = appInfo.version;
        
        this._cout.logStringMessage('_br_version ' + _br_version);
    },
    
    uninit : function(e) {
        this._cout.logStringMessage('AfUrlHelper REMOVE');
        
        this.proxyUninit();
        
        var container = window.gBrowser.tabContainer;
        
        container.removeEventListener("TabOpen", function (event) { AfUrlHelper.handleEvent (event); }, false);  
        container.removeEventListener("TabSelect", function (event) { AfUrlHelper.handleEvent (event); }, false);  
        container.removeEventListener("TabClose", function (event) { AfUrlHelper.handleEvent (event); }, false);  
        container.removeEventListener("resize", function (event) { AfUrlHelper.handleEvent (event); }, false); 
    },
    
};

AfUrlHelper.init();
